
	comment*
	-------------------------------------------------------------
	This simple font picker Dlg Box demonstrates how to enumerate
	fonts, sizes, print the sample text
	shaka_zulu@mail.bg
	-------------------------------------------------------------
	*

	.586
	.model flat,stdcall
	option casemap:none
	
	
	include windows.inc
	include kernel32.inc
	include user32.inc
	include gdi32.inc
	
	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib
	
	EnumFontsProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	AddFontSizes PROTO
	SampleTextCtrl PROTO :DWORD,:DWORD,:DWORD,:DWORD
	PrintSampleText PROTO :DWORD
	DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD


	.const
	IDD_DIALOG equ 1500
	IDC_CHECKBOXFONTS1 equ 1501
	IDC_CHECKBOXFONTS2 equ 1502
	IDC_CHECKBOXFONTS3 equ 1503
	IDC_BUTTONFONTSAPPLY equ 1504
	IDC_BUTTONFONTSOK equ 1505
	IDC_BUTTONFONTSCANCEL equ 1506
	IDC_LISTBOXFONTS equ 1507
	IDC_SAMPLETEXT equ 1511
	IDC_COMBOBOXFONTS1 equ 1520
	IDC_COMBOBOXFONTS2 equ 1521
	IDC_COMBOBOXQUALITY equ 1522
	
	
	;//the static's message for printing the text:
	SAMPLE_PRINT  equ WM_USER+1 ;the wParam contains the HFONT
	
	.data
	fonts_list dd 256 dup(0)
	combo1_id dd 0
	szSampleText db "Sample Text",0
	format_str db "%lu",0
	temp_FontQuality dd DEFAULT_QUALITY ;//default
	
	quality1 db "DEFAULT_QUALITY",0
	quality2 db "ANTIALIASED_QUALITY",0
	quality3 db "NONANTIALIASED_QUALITY",0
	quality4 db "CLEARTYPE_QUALITY",0
	quality5 db "CLEARTYPE_NATURAL_QUALITY",0
	
	.data?
	lf LOGFONT <> ;//for the enumeration
	hInstance HINSTANCE ?
	hCombo1 HANDLE ?
	hCombo2 HANDLE ?
	hCheck3 HANDLE ?
	hSample HANDLE ?
	hdcSample HDC ?
	hComboQ HANDLE ?
	DlgMainProc1 dd ?
	id_list dd 3 dup(?)
	
	
	.code
	start:
		invoke GetModuleHandle,NULL
		mov hInstance,eax
		invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
		invoke ExitProcess,NULL

DlgProc PROC hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		
		.if uMsg == WM_CLOSE
			invoke EndDialog,hDlg,NULL
			
		.elseif uMsg == WM_INITDIALOG
			invoke GetDlgItem,hDlg,IDC_COMBOBOXFONTS1
			mov hCombo1,eax
			invoke GetDlgItem,hDlg,IDC_COMBOBOXFONTS2
			mov hCombo2,eax
			invoke GetDlgItem,hDlg,IDC_SAMPLETEXT
			mov hSample,eax
			invoke GetDlgItem,hDlg,IDC_CHECKBOXFONTS3
			mov hCheck3,eax
			invoke GetDlgItem,hDlg,IDC_COMBOBOXQUALITY
			mov hComboQ,eax
		

			;//subclassing the hSample
			invoke SetWindowLong,hSample,GWL_WNDPROC,addr SampleTextCtrl
			mov DlgMainProc1,eax
			
			;//enumerate the fonts:
			invoke RtlZeroMemory,addr lf,sizeof LOGFONT
			mov lf.lfCharSet,DEFAULT_CHARSET
			invoke GetDC,hSample
			mov hdcSample,eax
			invoke EnumFontFamiliesEx,hdcSample,addr lf,addr EnumFontsProc,addr fonts_list,0
			
			;//adding the font sizes:
			invoke AddFontSizes
			
			;//set startup selected item in the combobox
			invoke SendMessage,hCombo1,CB_SETCURSEL,-1,0
			invoke SendMessage,hCombo2,CB_SETCURSEL,-1,0
			
			;//the font quality strings into the combobox
			invoke SendMessage,hComboQ,CB_ADDSTRING,0,addr quality1
			invoke SendMessage,hComboQ,CB_SETITEMDATA,eax,DEFAULT_QUALITY
			invoke SendMessage,hComboQ,CB_ADDSTRING,0,addr quality2
			invoke SendMessage,hComboQ,CB_SETITEMDATA,eax,ANTIALIASED_QUALITY
			invoke SendMessage,hComboQ,CB_ADDSTRING,0,addr quality3
			invoke SendMessage,hComboQ,CB_SETITEMDATA,eax,NONANTIALIASED_QUALITY
			invoke SendMessage,hComboQ,CB_ADDSTRING,0,addr quality4
			invoke SendMessage,hComboQ,CB_SETITEMDATA,eax,CLEARTYPE_QUALITY
			invoke SendMessage,hComboQ,CB_ADDSTRING,0,addr quality5
			invoke SendMessage,hComboQ,CB_SETITEMDATA,eax,CLEARTYPE_NATURAL_QUALITY
			invoke SendMessage,hComboQ,CB_SETCURSEL,0,0
			
		.elseif uMsg == WM_CTLCOLORSTATIC
			;/////////////////////////////////////////////////////////////////////////////
			;// changing the background and text color of the 'Sample Text' static control
			;/////////////////////////////////////////////////////////////////////////////
			mov eax,lParam
			.if eax == hSample
				;//getting the hdc for future use /print/:
				push wParam
				pop hdcSample
				invoke SetBkColor,wParam,White
				invoke SetTextColor,wParam,Black
				invoke GetStockObject,WHITE_BRUSH
				ret	
			.endif
			
		.elseif uMsg == WM_COMMAND
			mov eax,wParam
			and eax,0ffffh
			
			.if eax == IDC_CHECKBOXFONTS1
				invoke PrintSampleText,hDlg
				
			.elseif eax == IDC_CHECKBOXFONTS2
				invoke PrintSampleText,hDlg
				
			.elseif eax == IDC_CHECKBOXFONTS3
				invoke PrintSampleText,hDlg
				
			.elseif eax == IDC_COMBOBOXFONTS1 ;//only if fontname for ALL is selected,changes will be global!
				mov eax,wParam
				shr eax,16
				.if eax == CBN_SELCHANGE
					invoke PrintSampleText,hDlg
				.endif
				
			.elseif eax == IDC_COMBOBOXFONTS2
				mov eax,wParam
				shr eax,16
				.if eax == CBN_SELCHANGE
					invoke PrintSampleText,hDlg
				.endif
				
			.elseif eax == IDC_COMBOBOXQUALITY
				mov eax,wParam
				shr eax,16
				.if eax == CBN_SELCHANGE
					invoke SendMessage,hComboQ,CB_GETCURSEL,0,0
					invoke SendMessage,hComboQ,CB_GETITEMDATA,eax,0
					mov temp_FontQuality,eax
					invoke PrintSampleText,hDlg
				.endif
				
			.endif
		.endif
		
xor eax,eax
ret
DlgProc ENDP


SampleTextCtrl PROC hCtrl:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	LOCAL rcSample:RECT
	LOCAL textmetric :TEXTMETRIC
			
		mov eax,uMsg
		
		.if eax == SAMPLE_PRINT
			;//print the "sample text"
			invoke GetClientRect,hSample,addr rcSample
			invoke GetDC,hSample
			mov hdcSample,eax
			invoke SetTextAlign,hdcSample,TA_CENTER
			;//setting the font for printing
			invoke SelectObject,hdcSample,wParam 
			;//clear the static
			invoke SendMessage,hSample,WM_PAINT,hdcSample,0
			mov eax,rcSample.right
			shr eax,1
			mov rcSample.right,eax
			
			invoke GetTextMetrics,hdcSample,addr textmetric
			
			mov ebx,textmetric.tmHeight
			shr ebx,1
			mov eax,rcSample.bottom
			shr eax,1
			sub eax,ebx
			mov rcSample.bottom,eax
			
			invoke TextOut,hdcSample,rcSample.right,rcSample.bottom,addr szSampleText,sizeof szSampleText-1	
		.endif	

invoke CallWindowProc,DlgMainProc1,hCtrl,uMsg,wParam,lParam
ret
SampleTextCtrl ENDP



PrintSampleText PROC hDlg:DWORD

	LOCAL hFont		:HFONT
	LOCAL fdwBold 		:DWORD
	LOCAL fdwItalic 	:DWORD
	LOCAL fdwUnderline 	:DWORD
	LOCAL fontsize		:DWORD
	LOCAL szBuff[64]	:BYTE
		
		invoke IsDlgButtonChecked,hDlg,IDC_CHECKBOXFONTS1
		.if eax
			mov fdwBold,FW_BOLD
		.else
			mov fdwBold,FALSE
		.endif
		
		invoke IsDlgButtonChecked,hDlg,IDC_CHECKBOXFONTS2
		.if eax
			mov fdwItalic,TRUE
		.else
			mov fdwItalic,FALSE
		.endif
		
		invoke IsDlgButtonChecked,hDlg,IDC_CHECKBOXFONTS3
		.if eax
			mov fdwUnderline,TRUE
		.else
			mov fdwUnderline,FALSE
		.endif
		
		;///getting the fontname:
		invoke SendMessage,hCombo1,CB_GETCURSEL,0,0
		mov esi,eax
		invoke SendMessage,hCombo1,CB_GETLBTEXT,esi,addr szBuff
		
		;//getting the fontsize:
		invoke SendMessage,hCombo2,CB_GETCURSEL,0,0
		invoke SendMessage,hCombo2,CB_GETITEMDATA,eax,0
		add eax,3
		neg eax
		mov fontsize,eax
		
		invoke CreateFont,fontsize,0,0,0,fdwBold,fdwItalic,fdwUnderline,0,
			DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
			CLIP_DEFAULT_PRECIS,temp_FontQuality, 18,addr szBuff
		mov hFont,eax
		
		invoke SendMessage,hSample,SAMPLE_PRINT,hFont,0
		invoke DeleteObject,hFont
		
	ret
PrintSampleText ENDP


AddFontSizes PROC

	LOCAL count:DWORD
	LOCAL itemIndex :DWORD
	LOCAL szBuff[32]:BYTE
		
		mov itemIndex,0
		mov count,8 ;the minimum value
		.while count < 29 ;the maximum value is 28
			invoke wsprintf,addr szBuff,addr format_str,count
			invoke SendMessage,hCombo2,CB_ADDSTRING,0,addr szBuff
			invoke SendMessage,hCombo2,CB_SETITEMDATA,itemIndex,count
			inc count
			inc itemIndex
		.endw
		invoke SendMessage,hCombo2,CB_SETCURSEL,0,0
	ret
AddFontSizes ENDP

EnumFontsProc PROC PRIVATE lpelfe:DWORD,lpntme:DWORD,FontType:DWORD,lParam:DWORD
	
	LOCAL szBuff[256] :BYTE
		
		mov ebx,lpelfe
		lea esi, ENUMLOGFONTEX.elfFullName[ebx]
		.if byte ptr[esi] == 0
			xor eax,eax
			ret
		.endif
		invoke lstrcmp,addr szBuff,esi
		.if eax != 0
			invoke lstrcpy,addr szBuff,esi
			invoke SendMessage,hCombo1,CB_ADDSTRING,0,addr szBuff
		.endif
		add combo1_id,1
	mov eax,1
	ret
EnumFontsProc ENDP


END start


